import type {Meta, StoryObj} from '@storybook/web-components';
import {html} from 'lit';
import {SearchRoot} from '../search-root/search-root';
import {FacetCheckbox} from './facet-checkbox';

//@ts-expect-error required import.
const a = FacetCheckbox;
//@ts-expect-error required import.
const b = SearchRoot;

const meta: Meta = {
  title: 'Facets/facet-checkbox',
  tags: ['autodocs'],
  component: 'facet-checkbox',
  decorators: [
    (story) =>
      html`
        <search-root url="/mock/api/search/mock-index" defaultPerPage="10">
          ${story()}
        </search-root>
      `,
  ],
};

export default meta;
type Story = StoryObj;

export const Checkboxes: Story = {
  render: ({showCount, key, overrideLabel, showLabel, showReset, resetText}) =>
    html`<facet-checkbox
      ?showCount="${showCount}"
      key="${key}"
      overrideLabel="${overrideLabel}"
      ?showLabel="${showLabel}"
      ?showReset="${showReset}"
      ?resetText="${resetText}"
    ></facet-checkbox>`,
  args: {
    showCount: true,
    key: 'type',
    overrideLabel: '',
    showLabel: true,
    showReset: true,
    resetText: '',
  },
};

export const Radios: Story = {
  render: ({
    showCount,
    key,
    overrideLabel,
    showLabel,
    showReset,
    resetText,
    useRadios,
  }) =>
    html`<facet-checkbox
      ?showCount="${showCount}"
      key="${key}"
      overrideLabel="${overrideLabel}"
      ?showLabel="${showLabel}"
      ?showReset="${showReset}"
      ?resetText="${resetText}"
      ?useRadios="${useRadios}"
    ></facet-checkbox>`,
  args: {
    showCount: true,
    key: 'type',
    overrideLabel: '',
    showLabel: true,
    showReset: true,
    resetText: '',
    useRadios: true,
  },
};

export const Collapsible: Story = {
  render: ({
    showCount,
    key,
    overrideLabel,
    showLabel,
    showReset,
    resetText,
    useRadios,
    collapsible,
    closed,
    showCountInCollapseLabel,
  }) =>
    html`<facet-checkbox
      ?showCount="${showCount}"
      key="${key}"
      overrideLabel="${overrideLabel}"
      ?showLabel="${showLabel}"
      ?showReset="${showReset}"
      ?resetText="${resetText}"
      ?useRadios="${useRadios}"
      ?collapsible="${collapsible}"
      ?closed="${closed}"
      ?showCountInCollapseLabel="${showCountInCollapseLabel}"
    ></facet-checkbox>`,
  args: {
    showCount: true,
    key: 'type',
    overrideLabel: '',
    showLabel: true,
    showReset: true,
    resetText: '',
    useRadios: false,
    collapsible: true,
    closed: true,
    showCountInCollapseLabel: true,
  },
};
