import type {Meta, StoryObj} from '@storybook/web-components';
import {html} from 'lit';
import {SearchRoot} from '../search-root/search-root';
import {FacetDropdownHtml} from './facet-dropdown-html';

//@ts-expect-error required import.
const a = FacetDropdownHtml;
//@ts-expect-error required import.
const b = SearchRoot;

const meta: Meta = {
  title: 'Facets/facet-dropdown-html',
  tags: ['autodocs'],
  component: 'facet-dropdown-html',
  decorators: [
    (story) =>
      html`
        <search-root url="/mock/api/search/mock-index" defaultPerPage="10">
          ${story()}
        </search-root>
      `,
  ],
};

export default meta;
type Story = StoryObj;

export const Primary: Story = {
  render: ({key, overrideLabel, showLabel}) =>
    html`<facet-dropdown-html
      key="${key}"
      overrideLabel="${overrideLabel}"
      ?showLabel="${showLabel}"
    ></facet-dropdown-html>`,
  args: {
    key: 'type',
    overrideLabel: '',
    showLabel: true,
  },
};

export const Collapsible: Story = {
  render: ({
    key,
    overrideLabel,
    showLabel,
    collapsible,
    closed,
    showCountInCollapseLabel,
  }) =>
    html`<facet-dropdown-html
      key="${key}"
      overrideLabel="${overrideLabel}"
      ?showLabel="${showLabel}"
      ?collapsible="${collapsible}"
      ?closed="${closed}"
      ?showCountInCollapseLabel="${showCountInCollapseLabel}"
    ></facet-dropdown-html>`,
  args: {
    key: 'type',
    overrideLabel: '',
    showLabel: true,
    collapsible: true,
    closed: true,
    showCountInCollapseLabel: true,
  },
};
